/* ErrorView.c generated by valac 0.48.7, the Vala compiler
 * generated from ErrorView.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <flatpak.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <granite.h>

#define TYPE_ABSTRACT_VIEW (abstract_view_get_type ())
#define ABSTRACT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_VIEW, AbstractView))
#define ABSTRACT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_VIEW, AbstractViewClass))
#define IS_ABSTRACT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_VIEW))
#define IS_ABSTRACT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_VIEW))
#define ABSTRACT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_VIEW, AbstractViewClass))

typedef struct _AbstractView AbstractView;
typedef struct _AbstractViewClass AbstractViewClass;
typedef struct _AbstractViewPrivate AbstractViewPrivate;

#define SIDELOAD_TYPE_ERROR_VIEW (sideload_error_view_get_type ())
#define SIDELOAD_ERROR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorView))
#define SIDELOAD_ERROR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorViewClass))
#define SIDELOAD_IS_ERROR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDELOAD_TYPE_ERROR_VIEW))
#define SIDELOAD_IS_ERROR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDELOAD_TYPE_ERROR_VIEW))
#define SIDELOAD_ERROR_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorViewClass))

typedef struct _SideloadErrorView SideloadErrorView;
typedef struct _SideloadErrorViewClass SideloadErrorViewClass;
typedef struct _SideloadErrorViewPrivate SideloadErrorViewPrivate;
enum  {
	SIDELOAD_ERROR_VIEW_0_PROPERTY,
	SIDELOAD_ERROR_VIEW_ERROR_PROPERTY,
	SIDELOAD_ERROR_VIEW_NUM_PROPERTIES
};
static GParamSpec* sideload_error_view_properties[SIDELOAD_ERROR_VIEW_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AbstractView {
	GtkGrid parent_instance;
	AbstractViewPrivate * priv;
	GtkButtonBox* button_box;
	GtkGrid* content_area;
	GtkImage* badge;
	GtkLabel* primary_label;
	GtkLabel* secondary_label;
};

struct _AbstractViewClass {
	GtkGridClass parent_class;
};

struct _SideloadErrorView {
	AbstractView parent_instance;
	SideloadErrorViewPrivate * priv;
};

struct _SideloadErrorViewClass {
	AbstractViewClass parent_class;
};

struct _SideloadErrorViewPrivate {
	GError* _error;
};

static gint SideloadErrorView_private_offset;
static gpointer sideload_error_view_parent_class = NULL;

GType abstract_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AbstractView, g_object_unref)
GType sideload_error_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SideloadErrorView, g_object_unref)
SideloadErrorView* sideload_error_view_new (GError* _error_);
SideloadErrorView* sideload_error_view_construct (GType object_type,
                                                  GError* _error_);
static gchar* sideload_error_view_prettify_flatpak_error (GError* e);
GError* sideload_error_view_get_error (SideloadErrorView* self);
static void sideload_error_view_set_error (SideloadErrorView* self,
                                    GError* value);
static GObject * sideload_error_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void sideload_error_view_finalize (GObject * obj);
static GType sideload_error_view_get_type_once (void);
static void _vala_sideload_error_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_sideload_error_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
sideload_error_view_get_instance_private (SideloadErrorView* self)
{
	return G_STRUCT_MEMBER_P (self, SideloadErrorView_private_offset);
}

SideloadErrorView*
sideload_error_view_construct (GType object_type,
                               GError* _error_)
{
	SideloadErrorView * self = NULL;
	g_return_val_if_fail (_error_ != NULL, NULL);
	self = (SideloadErrorView*) g_object_new (object_type, "error", _error_, NULL);
	return self;
}

SideloadErrorView*
sideload_error_view_new (GError* _error_)
{
	return sideload_error_view_construct (SIDELOAD_TYPE_ERROR_VIEW, _error_);
}

static gchar*
sideload_error_view_prettify_flatpak_error (GError* e)
{
	gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (e != NULL, NULL);
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_ALREADY_INSTALLED)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("This app is already installed."));
		result = _tmp0_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_NEED_NEW_FLATPAK)) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("A newer version of Flatpak is needed to install this app."));
		result = _tmp1_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_REMOTE_NOT_FOUND)) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("A required Flatpak remote was not found."));
		result = _tmp2_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_RUNTIME_NOT_FOUND)) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (_ ("A required runtime dependency could not be found."));
		result = _tmp3_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_INVALID_REF)) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (_ ("The supplied .flatpakref file does not seem to be valid."));
		result = _tmp4_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_UNTRUSTED)) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (_ ("The app is not signed with a trusted signature."));
		result = _tmp5_;
		return result;
	}
	if (g_error_matches (e, FLATPAK_ERROR, FLATPAK_ERROR_INVALID_NAME)) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup (_ ("The application, runtime, or remote name is invalid."));
		result = _tmp6_;
		return result;
	}
	_tmp7_ = g_strdup (_ ("An unknown error occured."));
	result = _tmp7_;
	return result;
}

GError*
sideload_error_view_get_error (SideloadErrorView* self)
{
	GError* result;
	GError* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_error;
	result = _tmp0_;
	return result;
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static void
sideload_error_view_set_error (SideloadErrorView* self,
                               GError* value)
{
	g_return_if_fail (self != NULL);
	if (sideload_error_view_get_error (self) != value) {
		GError* _tmp0_;
		_tmp0_ = _g_error_copy0 (value);
		_g_error_free0 (self->priv->_error);
		self->priv->_error = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sideload_error_view_properties[SIDELOAD_ERROR_VIEW_ERROR_PROPERTY]);
	}
}

static GObject *
sideload_error_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SideloadErrorView * self;
	GtkImage* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GError* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkTextView* details_view = NULL;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextView* _tmp16_;
	GtkTextView* _tmp17_;
	GtkTextView* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkScrolledWindow* scroll_box = NULL;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkScrolledWindow* _tmp22_;
	GtkScrolledWindow* _tmp23_;
	GtkTextView* _tmp24_;
	GtkExpander* expander = NULL;
	GtkExpander* _tmp25_;
	GtkExpander* _tmp26_;
	GtkExpander* _tmp27_;
	GtkScrolledWindow* _tmp28_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkGrid* _tmp31_;
	GtkExpander* _tmp32_;
	GtkButtonBox* _tmp33_;
	GtkButton* _tmp34_;
	parent_class = G_OBJECT_CLASS (sideload_error_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorView);
	_tmp0_ = ((AbstractView*) self)->badge;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
	_tmp2_ = _tmp1_;
	g_object_set (_tmp0_, "gicon", (GIcon*) _tmp2_, NULL);
	_g_object_unref0 (_tmp2_);
	_tmp3_ = ((AbstractView*) self)->primary_label;
	gtk_label_set_label (_tmp3_, _ ("Install failed"));
	_tmp4_ = ((AbstractView*) self)->secondary_label;
	_tmp5_ = self->priv->_error;
	_tmp6_ = sideload_error_view_prettify_flatpak_error (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp4_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = (GtkTextView*) gtk_text_view_new ();
	g_object_ref_sink (_tmp8_);
	details_view = _tmp8_;
	_tmp9_ = details_view;
	gtk_container_set_border_width ((GtkContainer*) _tmp9_, (guint) 6);
	_tmp10_ = details_view;
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = self->priv->_error;
	_tmp14_ = _tmp13_->message;
	g_object_set (_tmp12_, "text", _tmp14_, NULL);
	_tmp15_ = details_view;
	gtk_text_view_set_editable (_tmp15_, FALSE);
	_tmp16_ = details_view;
	gtk_text_view_set_pixels_below_lines (_tmp16_, 3);
	_tmp17_ = details_view;
	gtk_text_view_set_wrap_mode (_tmp17_, GTK_WRAP_WORD);
	_tmp18_ = details_view;
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
	gtk_style_context_add_class (_tmp19_, GRANITE_STYLE_CLASS_TERMINAL);
	_tmp20_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp20_);
	scroll_box = _tmp20_;
	_tmp21_ = scroll_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 12);
	_tmp22_ = scroll_box;
	gtk_scrolled_window_set_min_content_height (_tmp22_, 70);
	_tmp23_ = scroll_box;
	_tmp24_ = details_view;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkExpander*) gtk_expander_new (_ ("Details"));
	g_object_ref_sink (_tmp25_);
	expander = _tmp25_;
	_tmp26_ = expander;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp26_, TRUE);
	_tmp27_ = expander;
	_tmp28_ = scroll_box;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = (GtkButton*) gtk_button_new_with_label (_ ("Close"));
	g_object_ref_sink (_tmp29_);
	close_button = _tmp29_;
	_tmp30_ = close_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp30_, "app.quit");
	_tmp31_ = ((AbstractView*) self)->content_area;
	_tmp32_ = expander;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = ((AbstractView*) self)->button_box;
	_tmp34_ = close_button;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (close_button);
	_g_object_unref0 (expander);
	_g_object_unref0 (scroll_box);
	_g_object_unref0 (details_view);
	return obj;
}

static void
sideload_error_view_class_init (SideloadErrorViewClass * klass,
                                gpointer klass_data)
{
	sideload_error_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SideloadErrorView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sideload_error_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sideload_error_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = sideload_error_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = sideload_error_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDELOAD_ERROR_VIEW_ERROR_PROPERTY, sideload_error_view_properties[SIDELOAD_ERROR_VIEW_ERROR_PROPERTY] = g_param_spec_pointer ("error", "error", "error", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
sideload_error_view_instance_init (SideloadErrorView * self,
                                   gpointer klass)
{
	self->priv = sideload_error_view_get_instance_private (self);
}

static void
sideload_error_view_finalize (GObject * obj)
{
	SideloadErrorView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorView);
	_g_error_free0 (self->priv->_error);
	G_OBJECT_CLASS (sideload_error_view_parent_class)->finalize (obj);
}

static GType
sideload_error_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SideloadErrorViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sideload_error_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SideloadErrorView), 0, (GInstanceInitFunc) sideload_error_view_instance_init, NULL };
	GType sideload_error_view_type_id;
	sideload_error_view_type_id = g_type_register_static (TYPE_ABSTRACT_VIEW, "SideloadErrorView", &g_define_type_info, 0);
	SideloadErrorView_private_offset = g_type_add_instance_private (sideload_error_view_type_id, sizeof (SideloadErrorViewPrivate));
	return sideload_error_view_type_id;
}

GType
sideload_error_view_get_type (void)
{
	static volatile gsize sideload_error_view_type_id__volatile = 0;
	if (g_once_init_enter (&sideload_error_view_type_id__volatile)) {
		GType sideload_error_view_type_id;
		sideload_error_view_type_id = sideload_error_view_get_type_once ();
		g_once_init_leave (&sideload_error_view_type_id__volatile, sideload_error_view_type_id);
	}
	return sideload_error_view_type_id__volatile;
}

static void
_vala_sideload_error_view_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SideloadErrorView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorView);
	switch (property_id) {
		case SIDELOAD_ERROR_VIEW_ERROR_PROPERTY:
		g_value_set_pointer (value, sideload_error_view_get_error (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sideload_error_view_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SideloadErrorView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDELOAD_TYPE_ERROR_VIEW, SideloadErrorView);
	switch (property_id) {
		case SIDELOAD_ERROR_VIEW_ERROR_PROPERTY:
		sideload_error_view_set_error (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

